%% EFDD part I (of III)
 
% This function determines the PSD around the peaks. Maximum number
% of peaks to be analyzed is 4, using part I, II and III. Part I is capable of
% analyzing 19 peaks.

% Input:  OMEGA - MAC limit value
%         peak - Peak number determined from singular value plot
%         U - singular vectors
%         S - singular values
%         N_peaks - number of total peaks
%         N_dofs - number of DOF
%         N_freq - frequency length
% Output: sigma - singluar values for corresponding SDOF systems
%         mode_estimate - mode estimate at peak j
 
 function [sigma,mode_estimate] = MAC(OMEGA,peak,U,S,N_peaks,N_dofs,N_freq)

mode_estimate = zeros(N_dofs,N_peaks);

for j = 1:N_peaks;
    
    mode_estimate(:,j) = U(:,1,peak(j));
    
end
sigma = zeros(N_peaks,N_freq);
for i = 1:N_peaks; 
    if i == 1;
        j = peak(1);
    elseif i == 2;
        j = peak(2);
    elseif i == 3;
        j = peak(3);
    elseif i == 4;
        j = peak(4);    
    elseif i == 5;
        j = peak(5);
    elseif i == 6;
        j = peak(6);
    elseif i == 7;
        j = peak(7);    
    elseif i == 8;
        j = peak(8);
    elseif i == 9;
        j = peak(9);
    elseif i == 10;
        j = peak(10);
    elseif i == 11;
        j = peak(11);
    elseif i == 12;
        j = peak(12);
    elseif i == 13;
        j = peak(13);    
    elseif i == 14;
        j = peak(14);
    elseif i == 15;
        j = peak(15);
    elseif i == 16;
        j = peak(16);    
    elseif i == 17;
        j = peak(17);
    elseif i == 18;
        j = peak(18);
    elseif i == 19;
        j = peak(19);
    end 
        for n = 1:N_peaks; 
            for k = j:1:N_freq; 
                    A = abs(U(:,n,k)'*mode_estimate(:,i))^2; 
                    B = (U(:,n,k)'*U(:,n,k))*(mode_estimate(:,i)'*mode_estimate(:,i));
                    MAC = A/B;
                        if MAC > OMEGA;
                        sigma(i,k) = sigma(i,k) + S(n,n,k);
                        elseif MAC == OMEGA;
                        sigma(i,k) = sigma(i,k) + S(n,n,k);
                        elseif MAC < OMEGA;
                        break
                        end
            end
            for k = j-1:-1:1; 
                    A = abs(U(:,n,k)'*mode_estimate(:,i))^2; 
                    B = (U(:,n,k)'*U(:,n,k))*(mode_estimate(:,i)'*mode_estimate(:,i));
                    MAC = A/B;
                        if MAC > OMEGA;
                        sigma(i,k) = sigma(i,k) + S(n,n,k);
                        elseif MAC == OMEGA;
                        sigma(i,k) = sigma(i,k) + S(n,n,k);
                        elseif MAC < OMEGA;
                        break
                        end
            end
        end
end
end