%% Singular value decomposition of the PSD cube-matrix

% This function uses singular value decomposition on an estimated PSD cube.
% SVD is preformed at each descete frequency.

% Input:  G - PSD cube
%         N_dofs - number of DOF
%         N_freq - number of descrete frequencies
% Output: U,V - singular vectors
%         S - singular values

function [U,S,V] = SVD(G,N_dofs,N_freq)
U = zeros(N_dofs,N_dofs,N_freq);
S = zeros(N_dofs,N_dofs,N_freq);
V = zeros(N_dofs,N_dofs,N_freq);
for k = 1:N_freq;
        [U(:,:,k) , S(:,:,k) , V(:,:,k)] = svd(G(:,:,k)); 
end
end