%% EFDD part III (of III)

% Estimates the natural frequncies by zero-crossings from the correlation 
% function.

% Input:  corr_norm - normalized correlation
%         j, l, m, q - correlation interval for peak 1, 2, 3 and 4
%         peak - peak vector
%         xi - estimated damping ratios
%         fs - sampling frequency
% Output: wn - angular natural frequency
%         fn - natural frequency

function [wn,fn] = frequency_estimation(corr_norm,peak,j,l,m,q,xi,fs)
count = zeros(length(peak),1);
count_loc = zeros(length(peak),length(corr_norm(length(peak),:)));
for n = 1:length(peak);
    for i = 1:length(corr_norm(1,:))-1;
     if corr_norm(n,i) < 0 && corr_norm(n,i+1) > 0;
            count(n,1) = count(n,1) +1;
            count_loc(n,i) = count_loc(n,i) + (count(n,1) + 1);
     elseif corr_norm(n,i) < 0 && corr_norm(n,i+1) == 0
            continue
        elseif corr_norm(n,i) < 0 && corr_norm(n,i+1) < 0
            continue
        elseif corr_norm(n,i) == 0 && corr_norm(n,i+1) > 0
            continue
        elseif corr_norm(n,i) == 0 && corr_norm(n,i+1) > 0
            continue
        elseif corr_norm(n,i) == 0 && corr_norm(n,i+1) == 0
            continue
        elseif corr_norm(n,i) > 0 && corr_norm(n,i+1) > 0
            continue
        elseif corr_norm(n,i) > 0 && corr_norm(n,i+1) == 0
            continue
        elseif corr_norm(n,i) > 0 && corr_norm(n,i+1) < 0
           continue
     end
    end
end

for i = 1:length(peak);
    if i == 1;

[peaks_zc1, loc_zc1] = findpeaks(count_loc(1,:));
P_zc1 = polyfit(loc_zc1(j(1):j(2)),peaks_zc1(j(1):j(2)),1);
Y_zc1 = P_zc1(1)*loc_zc1 + P_zc1(2);
fd1 = P_zc1(1)*0.5*fs;
fn1 = fd1/sqrt(1-xi(1)^2);
    elseif i == 2;

[peaks_zc2, loc_zc2] = findpeaks(count_loc(2,:));
P_zc2 = polyfit(loc_zc2(l(1):l(2)),peaks_zc2(l(1):l(2)),1);
Y_zc2 = P_zc2(1)*loc_zc2 + P_zc2(2);
fd2 = P_zc2(1)*0.5*fs;
fn2 = fd2/sqrt(1-xi(2)^2);
    elseif i == 3;

[peaks_zc3, loc_zc3] = findpeaks(count_loc(3,:));
P_zc3 = polyfit(loc_zc3(m(1):m(2)),peaks_zc3(m(1):m(2)),1);
Y_zc3 = P_zc3(1)*loc_zc3 + P_zc3(2);
fd3 = P_zc3(1)*0.5*fs;
fn3 = fd3/sqrt(1-xi(3)^2);
    elseif i == 4;

[peaks_zc4, loc_zc4] = findpeaks(count_loc(4,:));
P_zc4 = polyfit(loc_zc4(q(1):q(2)),peaks_zc4(q(1):q(2)),1);
Y_zc4 = P_zc4(1)*loc_zc4 + P_zc4(2);
fd4 = P_zc4(1)*0.5*fs;
fn4 = fd4/sqrt(1-xi(4)^2);
    end
end
% Estimated natural frequencies
fn = [fn1 fn2 fn3 fn4];
wn = (2*pi).*fn;
end